// keyboard (arrows, del, p, q, s, n, prev)
// context menu
// better options

(function ($) {
// BEGIN OF WRAPPER

var settings = {
		pfb : true,
		pmet : true,
		psrch : true,
		grps : true,
		btns : true,
		dnds : true,
		skin_l : true,
		skin_d : false,

		// the polloing interval
		interval : 3000,
		// whether to update immediately after a command is sent to the server
		update_after_cmd : true,
		// when this count is reached, polling is stopped an error message is shown
		max_errors : 5
	},
	// drag stuff
	move = {
		is_down : false,
		is_drag : false
	},
	// the state poll timeout
	state_to	= false,
	// the progress update
	progress_to	= false,
	// error counter
	errors		= 0,
	// the last state received
	last_data	= {},
	// the last browser state received
	last_browser	= {},
	// the last state received parsed in strings
	last_str	= [],
	// array of selected items
	selected	= [],
	// the item last clicked
	last_selected = false;

// Helper functions
function save_settings() {
	var date = new Date(),
		values = [];
	date.setTime(date.getTime() + (30 * 24 * 60 * 60 * 1000));
	$("#settings input").each(function () {
		values.push(this.id + ":" + (this.checked ? 1 : 0) );
	});
	document.cookie = 'settings=' + values.join("|") + '; expires=' + date.toUTCString() + '; path=/';
}
function restore_settings() {
	if (document.cookie && document.cookie != '') {
		var cookies = document.cookie.split(';'), 
			s = "";
		for (var i = 0; i < cookies.length; i++) {
			var cookie = $.trim(cookies[i]);
			// Does this cookie string begin with the name we want?
			if (cookie.substring(0, 9) == ('settings=')) {
				s = decodeURIComponent(cookie.substring(9)).split("|");
				for(var j = 0, l = s.length, k = ""; j < l; j++) {
					k = s[j].split(":");
					settings[k[0]] = parseInt(k[1],10) ? true : false;
				}
				break;
			}
		}
	}
}

function echo_time(s) {
	var h = 0, 
		m = 0,
		val = "";
	while(s >= 60) { s = s - 60; m++; }
	while(m >= 60) { m = m - 60; h++; }
	if(h > 0) { val += h + ":"; }
	if(m < 10) { m = "0" + m; } 
	if(s < 10) { s = "0" + s; }
	val += m + ":" + s;
	return val;
}
function update_progress(is_playing, is_paused, tm, ln) {
	var $progress = $("#progress");
	if(progress_to) { clearTimeout(progress_to); }
	if(is_playing) {
		$("#pp").addClass("button_pause");
		$progress.children("span")
			.text(echo_time(tm) + " / " + echo_time(ln))
			.parent().children("div")
				.width( (tm / ln) * ($progress.width() - 2) + "px");
	}
	else {
		$("#pp").removeClass("button_pause");
		if(!is_paused) { $progress.children("span").text("Playback stopped").parent().children("div").width(0); }
		else { $progress.children("span").text("Playback paused").parent().children("div").width(0); }
	}
	if(is_playing && settings.interval > 500) {
		progress_to = setTimeout( (function (a, b) { return function () { update_progress(true, false, a, b); }; }) (tm + 1, ln), 1000);
	}
}
function clean_playlist_name(nm) {
	return nm.replace(" [Playing]","").replace(/ \(\d+\)$/i,'');
}
function clear_selection() {
	var sel;
	if(document.selection && document.selection.empty) { document.selection.empty(); }
	else {
		if(window.getSelection) {
			sel = window.getSelection();
			try { 
				sel.removeAllRanges();
				sel.collpase();
			} catch (err) { }
		}
	}
}
function sync_heights() {
	var h = $(window).height() > 500 ? $(window).height() : 500, 
		l = $("#left").height(), 
		p = $("#playlist_items").height();

	$("#container").height(h - 20);
	$("#playlist_items").height(p + (h - 30 - l));
	$("#files_items").height($("#left").height() - 54);
}

// update various items in the interface
function update(what, data, full) {
	var tmp = false;
	switch(what) {
		case "browser":
			var $path = $("#path"),
				$files_items = $("#files_items");

			$path.empty();
			$.each(data.path, function (i, val) { 
				$path.append("<a href='#' rel='" + val.cmd + "'>" + val.path.replace(/\\+$/g,"") + "</a>"); 
			});
			// Update file browser height as path may be multiline
			$files_items.height($("left").height() - ($files_items.prevAll(".controls:eq(0)").height() + 34));

			// Display returned items
			tmp = $("<ol>");
			// Add the up control
			$("<li>", {
					"title" : "Go to parent",
					"rel" : decodeURI(data.parent),
					"class" : "item up",
					"html" : "<ins>&nbsp;</ins>" + ".."
				}).appendTo(tmp);
			// Add all items
			$.each(data.browser, function (i, val) {
				$("<li>", {
					"title" : val.p,
					"rel" : val.pu,
					"class" : "item" + (i % 2 == 1 ? " odd" : "") + " " + (val.ft === "" || val.fs === "" ? "folder" : "file"),
					"html" : "<a href='#' title='Queue to playlist' class='button " + (val.ft === "" || val.fs === "" ? "button_queue" : "button_add") + "'>&nbsp;</a><ins>&nbsp;</ins>" + val.p
				}).appendTo(tmp);
			});
			$files_items.empty().append(tmp.children());

			// Save a reference for later
			last_browser = data;
			break;
		case "now_playing_time":
			update_progress(parseInt(data.is_playing,10), parseInt(data.is_paused,10), parseInt(data.pos,10), parseInt(data.len,10));
			break;
		case "now_playing":
			var a = data.meta.split("#|#");
			document.title = (a[0] && a[2]) ? a[0] + " - " + a[2] : "Foobar remote";
			$("#image img").attr("src", data.art);
			tmp	= $("<ol>");
			$("<li>", { "title" : a[0] || "", "class" : "item", "html" : "<span class='label'>Artist</span>"	+ ( a[0] || "" ) }).appendTo(tmp);
			$("<li>", { "title" : a[1] || "", "class" : "item odd", "html" : "<span class='label'>Album</span>"	+ ( a[1] || "" ) }).appendTo(tmp);
			$("<li>", { "title" : a[2] || "", "class" : "item", "html" : "<span class='label'>Track</span>"		+ ( a[2] || "" ) }).appendTo(tmp);
			$("<li>", { "title" : a[3] || "", "class" : "item odd", "html" : "<span class='label'>Year</span>"	+ ( a[3] || "" ) }).appendTo(tmp);
			$("<li>", { "title" : a[4] || "", "class" : "item", "html" : "<span class='label'>Meta</span>"		+ ( a[4] || "" ) }).appendTo(tmp);
			$("#meta").empty().append(tmp.children());
			break;
		case "volume":
			if(parseInt(data.db,10) != 1000) {
				$("#volume > .slider > div").width( parseFloat(data.perc)/100 * ($("#volume > .slider").width() - 2) + "px")
					.parent().children("span").text(data.perc);
				$("#button_mute").removeClass("button_down");
			}
			else { 
				$("#button_mute").addClass("button_down"); 
			}
			break;
		case "playlists":
			tmp = $("<ol>");
			$.each(data.js, function (i, val) {
				$("<option>", { "value" : i, "text" : val.name + " (" + val.count + ")" + (i == data.pl ? " [Playing]" : "") }).appendTo(tmp);
			});
			$("#playlists").empty().append(tmp.children()).val(data.ac);
			break;
		case "playlist":
			tmp = $("<ol>");
			var last = "", 
				is_dif = true;
			$.each(data.js, function (i, val) {
				i = parseInt(data.pages,10) > 1 ? (parseInt(data.page,10) - 1) * parseInt(data.ipp,10) + i : i;
				is_dif = (last.a != val.a || last.b != val.b) ? true : false;
				if(settings.grps && is_dif) {
					$("<li>", {
						"class" : "album",
						"html" : "<a href='#' style='float:right;' title='Remove album from playlist' class='button button_remove'>&nbsp;</a>" + val.a + " - " + val.b
					}).appendTo(tmp);
				}
				$("<li>", { // data.foc
					"class" : "item " + (data.ip == i && data.pa === data.pp ? "active " : "") + ($.inArray(i, selected[data.pa]) !== -1 ? "selected " : "") + ( i%2 == 1 ? " odd" : "" ),
					"html" : (settings.btns ? "<a href='#' title='Remove from playlist' class='button button_remove'>&nbsp;</a><a href='#' title='Dequeue' class='button button_dequeue'>&nbsp;</a><a href='#' title='Queue' class='button button_queue'>&nbsp;</a>" : "" ) + "<span class='q'>&nbsp;" + val.n + (data.ip == i && data.pa === data.pp ? "&raquo;" : "" ) + "</span><span class='n'>" + (i + 1) + ".</span>" + ( settings.grps ? "" : val.a + " - ") + val.t + " (" + val.l + ")",
					"rel" : i
				}).appendTo(tmp);
				last = val;
			});
			$("#playlist_items").empty().append(tmp.children());

			if(parseInt(data.pages,10) > 1) {
				$("#pages").show();
				$("#page_text").text(data.page + " of " + data.pages);
			}
			else { 
				$("#pages").hide(); 
			}
			break;
		case "order":
			$("#play_mode").val(data);
			break;
		case "search":
			$("#search_q").val(data);
			break;
		case "sac":
			if(data == "checked") { $("#sac").addClass("button_down"); }
			else { $("#sac").removeClass("button_down"); }
			break;
		case "saq":
			if(data == "checked") { $("#saq").addClass("button_down"); }
			else { $("#saq").removeClass("button_down"); }
			break;
		default:
			break;
	}
}

// Functions for getting state
var get_state;
function force_update(timeout) {
	if(typeof timeout == "undefined") { timeout = settings.interval; }
	if(state_to) { clearTimeout(state_to); }
	state_to = setTimeout(function () { get_state(); }, timeout);
}
get_state = function() {
	$.ajax({
		url			: "/vakata2/?param3=state.json", // use the `state.json` template
		dataType	: "json",
		type		: "GET",
		timeout		: settings.interval * 2 / 3,
		success		: function (data, t, x) {
			if(x.responseText) {
				var arr = x.responseText.split(/^"/mg), item;
				for(var i = 1, j = arr.length; i < j; i++) {
					if(arr[i] === last_str[i]) { continue; }
					item = arr[i].toString().replace(/^([a-z_]+).*/ig,"$1").replace(/[\r\n}]+/,"").toString();
					update(item, data[item], data);
					last_data[item] = data[item];
					last_str[i] = arr[i];
				}
				force_update();
			}
		},
		complete : function (x, t) { 
			if(x.responseText) { errors = 0; }
			else {
				// Shedule next update if error and total consecutive errors is less than 3
				errors ++;
				if(progress_to) { clearTimeout(progress_to); }
				if(errors < settings.max_errors) {
					force_update();
				}
				else {
					alert("Connection timed out - check if Foobar is running on the host and refresh this page.");
				}
			}
		}
	});
};

// Issue a command to foobar
function cmd(c, p1, p2) {
	var params = {};
	if (c) { params.cmd = c; }
	if (p1 || p1 == "0") { params.param1 = p1; }
	if (p2 || p2 == "0") { params.param2 = p2; }
	params.param3 = c !== 'Browse' ? 'NoResponse' : 'browser.json';
	$.get('/vakata2/', params, function (data) {
		if(c === "Browse" && !p2) { update("browser",data); }
	});
	if(settings.update_after_cmd) {
		force_update( c === "Start" || c === "PlayOrPause" ? 500 : 250 );
	}
}

// Attach all events and start updating
$(function () {
	var $tooltip = $("<div id='tooltip'></div>").appendTo("body");

	// Control both sliders (progress & volume)
	$(".slider")
		.bind("mouseenter mouseleave", function (event) { $tooltip[ event.type === "mouseenter" ? "show" : "hide" ](); })
		.bind("click mousemove", function (event) {
			var t = $(this), 
				o = t.offset(), 
				p = event.pageX - o.left, 
				perc = Math.min(parseInt(p/t.width()*100,10),100);
			if(event.type !== "mousemove") {
				var d = $(this).attr("data");
				if(d) { 
					if(!t.is("#progress") || parseInt(last_data.now_playing.is_playing,10) == 1) { cmd(d, perc); }
				}
			}
			else { 
				if(t.is("#progress")) { perc = echo_time(Math.round(last_data.now_playing_time.len*(perc/100))); }
				$tooltip.css({ left : event.pageX - 18, top : o.top - 15 }).text(perc);
			}
		});

	// Control all buttons
	$(".button").click(function (event) {
		var t = $(this).blur(),
			d = t.attr("data"),
			tmp = false;

		if(t.is(".button_toggle")) { t.toggleClass("button_down"); }

		switch(this.id) {
			case "add_playlist":
				tmp = prompt('Enter name for the new playlist', 'New playlist'); 
				if(tmp && tmp.length) {
					cmd('CreatePlaylist',tmp,(parseInt(last_data.playlist.pa,10) + 1)); 
				}
				break;
			case "remove_playlist":
				if(confirm('Are you sure you want to delete the `' + clean_playlist_name($('#playlists option:selected').text()) + '` playlist?')) {
					cmd('RemovePlaylist',$('#playlists').val()); 
				}
				break;
			case "rename_playlist":
				tmp = prompt('Enter new name for the playlist', clean_playlist_name($('#playlists option:selected').text())); 
				if(tmp && tmp.length) { 
					cmd('RenamePlaylist',tmp,last_data.playlist.pa);
				}
				break;
			case "empty_playlist":
				if(confirm('Are you sure you want to empty the `' + clean_playlist_name($('#playlists option:selected').text()) + '` playlist?')) {
					cmd('EmptyPlaylist');
				}
				break;
			/* NOT ISED ANYMORE - MOVED TO SETTINGS
			case "group":
				settings.group = !settings.group; 
				last_str = []; 
				force_update(250);
				break;
			*/
			case "sac":
			case "saq":
				cmd(this.id.toString().toUpperCase(), t.filter('.button_down').length); 
				break;
			case "queue_tracks":
				if(selected[last_data.playlist.pa] && selected[last_data.playlist.pa].length) {
					cmd('QueueItems',selected[last_data.playlist.pa].join(','));
				}
				break;
			case "dequeue_tracks":
				if(selected[last_data.playlist.pa] && selected[last_data.playlist.pa].length) {
					cmd('DequeueItems',selected[last_data.playlist.pa].join(','));
				}
				break;
			case "remove_tracks":
				if(selected[last_data.playlist.pa] && selected[last_data.playlist.pa].length && 
					confirm('Are you sure you want to delete the selected ' + selected[last_data.playlist.pa].length + ' tracks?')) { 
					cmd('Del',selected[last_data.playlist.pa].join(',')); 
					selected[last_data.playlist.pa] = []; 
				}
				break;
			case "prev_page":
				if(parseInt(last_data.playlist.page,10) > 1) {
					cmd('SwitchPlaylistPage',parseInt(last_data.playlist.page,10) - 1);
				}
				break;
			case "next_page":
				if(parseInt(last_data.playlist.page,10) - 1 < parseInt(last_data.playlist.pages,10)) { 
					cmd('SwitchPlaylistPage',parseInt(last_data.playlist.page,10) + 1);
				}
				break;
			case "dir_queue_recursive":
				if(last_browser.pathcurrent) {
					cmd('Browse', decodeURIComponent(last_browser.pathcurrent), 'EnqueueDirSubdirs');
				}
				break;
			case "dir_queue":
				if(last_browser.pathcurrent) {
					cmd('Browse', decodeURIComponent(last_browser.pathcurrent), 'EnqueueDir');
				}
				break;

			default:
				if(d) { cmd.apply(null, d.split(",")); }
				break;
		}

		event.preventDefault();
		return false;
	});

	// Control both dropdowns
	$("#play_mode").change(function () {
		this.blur();
		cmd("PlaybackOrder", $(this).val());
	});
	$("#playlists").change(function () {
		this.blur();
		cmd("SwitchPlaylist", $(this).val());
	});

	// Control playlist items
	$("#playlist_items")
		.delegate("li", "mouseup", function (event) {
			// return false;
		})
		.delegate(".item", "click", function (event) {
			var a = last_data.playlist.pa,
				t = $(this),
				i = parseInt(t.attr("rel"),10),
				p = $("#playlist_items");
			if((!event.ctrlKey && !event.shiftKey) || !$.isArray(selected[a])) {
				selected[a] = [];
				p.children(".selected").removeClass("selected");
			}

			if(event.ctrlKey && t.is(".selected")) {
				t.removeClass("selected");
				selected[a] = $.map(selected[a], function (n) { return n == i ? null : n; });
			}
			else if(event.shiftKey) {
				var n = Math.min(i, last_selected), 
					m = Math.max(i, last_selected),
					k = last_data.playlist.pages > 1 ? last_data.playlist.ipp * (last_data.playlist.page - 1) : 0,
					l = last_data.playlist.pages > 1 ? last_data.playlist.ipp * last_data.playlist.page : last_data.playlist.ipp;
				selected[a] = [];
				p.children(".selected").removeClass("selected");
				for(i = n; i <= m; i++) {
					if(i >= k && i <= l) { p.children("[rel=" + i + "]").addClass("selected"); }
					selected[a].push(i);
				}
			}
			else {
				t.addClass("selected");
				selected[a].push(i);
				last_selected = i;
			}
			clear_selection();
			event.preventDefault();
			return false;
		})
		.delegate("li", "dblclick", function (event) {
			cmd("Start", $(this).attr("rel"));
			$(this).siblings(".active").removeClass("active").end().addClass("active");
			clear_selection();
			event.preventDefault();
			return false;
		})
		.delegate(".button_dequeue", "click", function (event) {
			cmd("DequeueItems",$(this).parent().attr("rel"));
		})
		.delegate(".button_queue", "click", function (event) {
			cmd("QueueItems",$(this).parent().attr("rel"));
		})
		.delegate(".button_remove", "click", function (event) {
			var p = $(this).parent(), ids = [];
			if(p.is(".album")) {
				p.nextUntil(".album").each(function () {
					ids.push($(this).attr("rel"));
				});
				cmd("Del", ids.join(','));
			}
			else {
				cmd("Del",$(this).parent().attr("rel"));
			}
		})
		.delegate(".item", "mousedown", function (event) {
			if(move.is_down || !settings.dnds) return;
			try {
				event.currentTarget.unselectable = "on";
				event.currentTarget.onselectstart = function() { return false; };
				if(event.currentTarget.style) { event.currentTarget.style.MozUserSelect = "none"; }
			} catch(err) { }
			start_drag(event);
			move.item = $(this).attr("rel");
			move.is_selected = $(this).hasClass("selected");
			return false;
		})
		.delegate(".item", "mouseenter", function (event) {
			var t = $(this),
				r = parseInt(t.attr("rel"),10);
			if(settings.dnds && move.is_down && move.is_drag) {
				if(r < move.item) { t.css("borderTopColor","red"); }
				if(r > move.item) { t.css("borderBottomColor","red"); }
				if(t.is(":last-child")) { move.to = setTimeout('$("#next_page").click()', 1000); }
				if(t.is(":first-child")) { move.to = setTimeout('$("#prev_page").click()', 1000); }
			}
		})
		.delegate(".item", "mouseleave", function (event) {
			var t = $(this);
			if(move.to) { clearTimeout(move.to); }
			if(settings.dnds && move.is_drag) {
				t.css("borderColor","");
			}
		})
		.delegate(".item", "mouseup", function (event) {
			var t = $(this),
				r = parseInt(t.attr("rel"),10);
			if(settings.dnds && move.is_drag) {
				t.css("borderColor","");
				if(move.item != r) {
					cmd("Move", (move.is_selected ? selected.join(",") : move.item), r - move.item);
					if(move.is_selected) selected = [];
				}
			}
		});

	function start_drag(e) {
		var p = $("#playlist_items");
		if(!settings.dnds) return;
		move.is_down = true;
		move.init_x = e.pageX;
		move.init_y = e.pageY;
		move.pit = parseInt(p.offset().top,10);
		move.pib = parseInt(p.height(),10) + move.pit;
		var cnt = $(e.currentTarget).is("selected") ? selected.length : 1;
		$("#mover").text( cnt + " item" + (cnt > 1 ? "s" : ""));
		$(document).bind("mousemove", drag);
		$(document).bind("mouseup", stop_drag);
	}
	function drag(e) {
		if(!settings.dnds || !move.is_down) { return; }
		if(!move.is_drag) {
			if(Math.abs(e.pageX - move.init_x) > 5 || Math.abs(e.pageY - move.init_y) > 5) { 
				move.is_drag = true; 
				$("#mover").show();
			}
		}
		if(move.is_drag) {
			$("#mover").css({ "left" : (e.pageX + 7) + "px", "top" : (e.pageY + 15) + "px" });
			if(e.pageY > move.pib - 10) { 
				if(!move.scroll_i) { move.scroll_i = setInterval('p = document.getElementById("playlist_items"); p.scrollTop = p.scrollTop + 10;', 100); }
			}
			else if(e.pageY < move.pit) { 
				if(!move.scroll_i) { move.scroll_i = setInterval('p = document.getElementById("playlist_items"); p.scrollTop = p.scrollTop - 10;', 100); }
			}
			else {
				if(move.scroll_i) { clearInterval(move.scroll_i); move.scroll_i = false; }
			}
		}
	}
	function stop_drag(e) {
		if(move.to) { clearTimeout(move.to); }
		if(move.scroll_i) { clearInterval(move.scroll_i); move.scroll_i = false; }
		move.is_down = false;
		move.is_drag = false;
		$("#mover").hide();
		$(document).unbind("mousemove", drag);
		$(document).unbind("mouseup", stop_drag);
	}

	// Control files list
	$("#files_items")
		.delegate("li", "click", function (event) {
			if($(event.target).is(".button_queue")) { return; }
			if(!$(this).is(".file")) { cmd("Browse", decodeURIComponent($(this).attr("rel"))); }
		})
		.delegate("li", "dblclick", function (event) {
			if($(this).is(".file")) { cmd("Browse", decodeURIComponent($(this).attr("rel")), 'EnqueueDir'); }
			event.preventDefault();
			return false;
		})
		.delegate(".button_queue, .button_add", "click", function (event) {
			var li = $(this).parent();
			if(li.is(".file")) { cmd("Browse", decodeURIComponent(li.attr("rel")), 'EnqueueDir'); }
			else { cmd("Browse", decodeURIComponent(li.attr("rel")), 'EnqueueDirSubdirs'); }
			event.stopImmediatePropagation();
			return false;
		});


	$("#path").delegate("a","click", function (event) {
		this.blur();
		cmd("Browse", decodeURIComponent($(this).attr("rel")));
		event.preventDefault();
		return false;
	});

	$("#search_f").submit(function (event) {
		cmd('SearchMediaLibrary', $('#search_q').val()); 
		event.preventDefault();
		return false;
	});
	$("#search_q").val("Search media library")
		.focus(function () { if(this.value === "Search media library") { this.value = ""; } })
		.blur(function () { if(this.value === "") { this.value = "Search media library"; } });

	// Settings
	restore_settings();
	$.each(settings, function (i, val) {
		$("#" + i).attr("checked", val);
	});
	$("#settings")
		.bind("mouseenter", function () { $(this).stop(true).animate({ "top" : "0px" }, 500); })
		.bind("mouseleave", function () { $(this).stop(true).animate({ "top" : "-100px" }, 500); })
		.find(":radio").change(function (event) {
			var t = $(this);
			if(t.is(":checked")) $("html, body").attr("class", t.attr("rel"));
			save_settings();
		}).end()
		.find(":checkbox").change(function (event) {
			var t = $(this);
			switch(this.id) {
				case "psrch":
					$("#search")[ t.is(":checked") ? "show" : "hide" ]();
					sync_heights();
					break;
				case "pmet":
					$("#data")[ t.is(":checked") ? "show" : "hide" ]();
					sync_heights();
					break;
				case "pfb":
					if(t.is(":checked")) {
						$("#container").width(981);
						$("#right").show();
					}
					else {
						$("#right").hide();
						$("#container").width(500);
					}
					break;
				default:
					settings[this.id] = this.checked;
					last_str = [];
					force_update(250);
					break;
			}
			save_settings();
		}).end()
		.find("input").trigger("change");

	// Sync heights
	sync_heights();

	// OK - now init all panels
	get_state();
	cmd("Browse");
});

// END OF WRAPPER
})(jQuery);